<template>
  <div>
    <GoBack />
    <section>
      <div style="container align-items-center ">
      <span style="font-size: 300%; font-weight: bold;"
          class="flex-grow-1 text-center shadow-none"        
          @click="$emit('on-toggle')"
          v-if="!isEditing"
        >
        {{ todos.name }}
          </span>    
          <form v-else class="container flex-grow-1" @submit.prevent="finishEditing()">
            <input
              type="text"
              class="form-control"
              id="todo.idList"
              placeholder="Nouveau nom pour cette TodoList"
              v-model="newName"
              @blur="finishEditing()"
            />
          </form>
         
        <button
          @click="startEditing(todos.idList)"
          class="btn btn-outline-primary border-0 ml-2"
        >
        <span class="fa fa-edit"></span>
        </button>
      </div>
    </section>
    <div>
      <form class="container" @submit.prevent="addTodo(newTodo)">
        <input
          v-model="newTodo"
          type="text"
          class="form-control"
          placeholder="Créer un nouveau todo"
        />
      </form>
    </div>
    <br>
    <section class="container">
      <div>
        <div
          v-for="todoItem in todos.tasks_list"
          :key="todoItem.id"
        >
          <span>
            <li class="d-flex align-items-center list-group-item">
              <span class="flex-grow-1 text-center shadow-none">
                <router-link
                  :to="{
                    name: 'Todo',
                    params: { idList: todos.idList, id: todoItem.id }
                  }"
                >
                  <span>{{todoItem.id}} - {{ todoItem.name }}</span>
                </router-link>
              </span>
            </li>
          </span>
        </div>
      </div>
      <router-view :key="$route.path" />
    </section>
  </div>
</template>
<script>
import store from "@/store";
import GoBack from "@/components/GoBack";

export default {
  components: {
    GoBack
  },
  data() {
    return {
      newTodo : "",
      isEditing: false,
      todos: fetch("http://localhost:5000/lists/"+parseInt(this.idList)+"", {"Content-Type": "application/json"} )
        .then(response => response.json())
        .then(res => this.todos = JSON.parse(JSON.stringify(res)))
    };
  },
  props: {
    idList: Number
  },
  methods: {
    startEditing(listId) {
      if (this.isEditing) {
        this.finishEditing();
      } else {
        this.newName = this.name;
        this.isEditing = true;
      }
    },
    finishEditing() {
      this.isEditing = false;
      this.todos.name = this.newName;
      this.updateTodo(this.newName)
    },
    addTodo(newTodo) {
      if (newTodo.length > 0) {
        const requestOptions = {
          method: "PUT",
          headers: { "Content-Type": "application/json" },
          body: JSON.stringify({
            name: newTodo,
            created_on: new Date(),
          })
        };
        fetch("http://localhost:5000/lists/"+parseInt(this.idList)+"", requestOptions)
          .then(response => response.json())
          .then(res => this.todos = JSON.parse(JSON.stringify(res)));
      }
    },
    updateTodo(todo) {
      const requestOptions = {
          method: "PATCH",
          body: JSON.stringify({
            name: todo,
            created_on: new Date(),
          }),
          headers: { "Content-Type": "application/json" }
        };
        fetch("http://localhost:5000/lists/"+parseInt(this.idList)+"", requestOptions)
          .then(response => response.json())
          .then(data => console.log(data));
    }
  }
}
</script>
